<script setup lang="ts">
import { useEmpStore } from "../../stores/employee";
import { mdiMagnify, mdiPencil, mdiDelete, mdiPlus } from "@mdi/js";
import { onMounted, ref } from "vue";
import ConfirmDialog from "@/components/Dialog/ConfirmDialog.vue";

const employee = useEmpStore();
const confirmDlg = ref();

onMounted(async () => {
  await employee.getEmp();
});

const deleteEmp = async (id: number, name: string, surname: string) => {
  try {
    await confirmDlg.value.openDialog(
      "Please Confirm",
      `คุณต้องการลบ " ${name} ${surname} " หรือไม่`
    );
    employee.deleteEmployee(id);
  } catch (e) {
    /* empty */
  }
};
</script>

<template>
  <v-row>
    <v-col>
      <v-text-field
        label="Search"
        placeholder="employee"
        variant="underlined"
      ></v-text-field>
    </v-col>
    <v-col>
      <v-btn
        style="float: left"
        color="black"
        variant="outlined"
        :prepend-icon="mdiMagnify"
        >Search</v-btn
      >
      <v-btn
        style="margin-left: 11em"
        color="blue-darken-1"
        :prepend-icon="mdiPlus"
        @click="employee.dialog = true"
        >Add</v-btn
      >
    </v-col>
  </v-row>
  <v-toolbar color="#DED4F7">
    <v-row class="justify-center">
      <div class="text-h4">Employee</div>
    </v-row>
  </v-toolbar>
  <v-table>
    <thead>
      <tr>
        <th>ID</th>
        <th>Name</th>
        <th>Surname</th>
        <th>Username</th>
        <th>Password</th>
        <th>Tel.</th>
        <th>Role</th>
        <th></th>
        <th></th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="item of employee.emps" :key="item.id">
        <td>{{ item.id }}</td>
        <td>{{ item.name }}</td>
        <td>{{ item.surname }}</td>
        <td>{{ item.username }}</td>
        <td>{{ item.password }}</td>
        <td>{{ item.tel }}</td>
        <td>{{ item.role }}</td>
        <td>
          <v-btn
            :icon="mdiPencil"
            color="secondary"
            class="ma-1"
            @click="employee.editEmployee(item)"
          ></v-btn>
        </td>
        <td>
          <v-btn
            :icon="mdiDelete"
            color="error"
            class="ma-1"
            @click="deleteEmp(item.id!, item.name!, item.surname!)"
          ></v-btn>
        </td>
      </tr>
    </tbody>
  </v-table>
  <ConfirmDialog ref="confirmDlg"></ConfirmDialog>
</template>

<style scoped></style>
